#ifndef _fencer_input_h
#define _fencer_input_h

#include <SDL2/SDL_events.h>
#include <SDL2/SDL_scancode.h>
#include <SDL2/SDL_keyboard.h>

// input listener
typedef void (*InputActionDelegate)(void* object, int value);

extern void input_init();
extern void input_clean();

// handle an input event
extern void input_handle_event(SDL_Event event);

// create a new axis action triggering on a change of either 'negative' or 'positive' and invoking 'delegate' with first argument 'object'
extern void input_add_axis_action(void* object, InputActionDelegate delegate, SDL_Scancode negative, SDL_Scancode positive);
// create a new key action triggering on 'key' change invoking 'delegate' on 'object'.
extern void input_add_key_action(void* object, InputActionDelegate delegate, SDL_Scancode key);
// remove all actions related to 'object'.
extern void input_remove_actions(void* object);

#define InputDelegate(__Listener)\
    ((InputActionDelegate)&__Listener)

#endif // !_fencer_input_h
